﻿enum asEObjTypeFlags
{
	asOBJ_REF                        = (1<<0),
	asOBJ_VALUE                      = (1<<1),
	asOBJ_POD                        = (1<<3),
	asOBJ_NOCOUNT                    = (1<<18),
};

enum asECallConvTypes
{
	asCALL_CDECL             = 0,
	asCALL_STDCALL           = 1,
	asCALL_THISCALL_ASGLOBAL = 2,
	asCALL_THISCALL          = 3,
	asCALL_CDECL_OBJLAST     = 4,
	asCALL_CDECL_OBJFIRST    = 5,
	asCALL_GENERIC           = 6,
	asCALL_THISCALL_OBJLAST  = 7,
	asCALL_THISCALL_OBJFIRST = 8
};

uint64 vv(uint16 v1, uint16 v2, uint16 v3 = 0, uint16 v4 = 0)
{
    return (uint64(v1) << 48) | (uint64(v2) << 32) | (uint64(v3) << 16) | v4;
}

void testFind()
{
    string t = "123456712345";
    MsgBox(t.find("3"));
    MsgBox(t.find("3", 5));
}

void testSplitJoin()
{
	string t = "12|34|56|Привет\"\t\"";
    array<string> arr = t.split("|");
    for (uint i = 0; i < arr.length(); i++)
        MsgBox(arr[i]);
    MsgBox(join(arr, "-"));
 }

// Текст, который вернет эта функция, будет вставлен в начало модуля snegengine
string main()
{
    debugger();
    if (v8ver < vv(8, 2, 19) || (v8ver >= vv(8, 3, 0) && v8ver < vv(8, 3, 4))) { 
        MsgBox("Эта версия 1С не поддерживается.");
        int k = 0, c = 1/k; // сгенерим ошибку
    }    
    registerObjectType("Process", 4, asOBJ_REF | asOBJ_NOCOUNT);

    registerObjectType("BkEndUI", 4, asOBJ_REF | asOBJ_NOCOUNT);
    registerVirtualStdCall("Process", "BkEndUI@ getBkEndUI(const Guid &in=Guid={\"{614E1F45-71A9-11D4-B997-008048DA0334}\"})", 14);
    if (v8ver < vv(8, 3))
        registerVirtualStdCall("BkEndUI",
        "int messageBox(const v8string& in msg,uint type,uint timeout,int caption,int hparent,int& inout p,int=0,int=0,int=0)", 18);
    else if (v8ver < vv(8, 3, 5))
        registerVirtualStdCall("BkEndUI",
        "int messageBox(const v8string& in msg,uint type,uint timeout,int caption,int hparent,int& inout p,int=0,int=0,int=0,int=0,int=0)", 18);
    else
        registerVirtualStdCall("BkEndUI",
        "int messageBox(const v8string& in msg,uint type,uint timeout,int caption,int hparent,int& inout p,int=0,int=0,int=0,int=0,int=0)", 19);

    registerObjectType("mbp", 24, asOBJ_VALUE | asOBJ_POD);
    registerObjectProp("mbp", "int i1", 0);
    registerObjectProp("mbp", "int i2", 4);
    registerObjectProp("mbp", "int p1", 8);
    registerObjectProp("mbp", "int p2", 12);
    registerObjectProp("mbp", "int i3", 16);
    registerObjectProp("mbp", "int8 c1", 20);

    string coreName;
    if (v8ver < vv(8, 3))
        coreName = "core82.dll";
    else
        coreName = "core83.dll";
    uint hCore = getModuleHandle(coreName);
    registerMethodByAddress("", "Process& currentProcess()", getProcAddress(hCore, "?current_process@core@@YAPAVSCOM_Process@1@XZ"), asCALL_CDECL);
	
	return """
        int v8MsgBox(const string& text, const string& caption="") {
            BkEndUI@ ui = currentProcess().getBkEndUI();
            mbp m;
            m.i1 = m.i2 = m.i3 = 0;
            m.c1 = 2;
            m.p1 = m.p2 = getAddress(m.i1);
            return ui.messageBox(v8string(text), 0, 0, caption.isEmpty() ? 0 : caption.c_str(), -1, m.i1);
        }
    """;
}
